﻿{ Free Pascal }
const nmax=64; {верхня межа степеня}

type at=array[0..nmax] of qword;
     bt=array[0..nmax] of byte;

var m,n,t: qword;

a:  {знайдені числа відповіді}
     array[1..10000] of qword;

am,    {прості дільники m}
an,    {прості дільники n}
x: at; {часткові добутки числа відповіді}

bm,    {степені простих дільників m}
bn,    {степені простих дільників n}
bnt,   {степені простих дільників n,
        нерозподілені при переборі}
y: bt; {степені простих дільників m відповіді}

d:  {степені простих дільників n у розкладі
     на прості множники  степенів дільників
     m, збільшених на 1}
     array[1..nmax,1..nmax] of byte;

cm, {кількість різних простих дільників m}
cn, {кількість різних простих дільників n}
qn, {кількість простих дільників  n  з
     урахуванням кратності входження у
     розклад на прості множники}
j,k: byte;
na: word;    {кількість чисел відповіді}
fi,fo: text; {файли даних}

  {розкладання на прості множники m}
procedure decomp(var  m: qword;
                 var cm: byte;
                 var am: at;
                 var bm: bt);
var t,j0,j: qword;          BEGIN
cm:=0;
j0:=trunc(sqrt(m));
 t:=m;
 j:=1;
while ((0<cm) or (j<j0)) and (t>1)
  do                        begin
  inc(j);
  if (t mod j) = 0 then     begin
    inc(cm);
    am[cm]:=j;
    bm[cm]:=0;
    while (t mod j) = 0 do  begin
      inc(bm[cm]);
      t:=t div j      end end end;
if (cm=0) then begin
  cm:=1;
  am[1]:=m;
  bm[1]:=1                end END;

procedure QSort(l,r: word);
var i,j: word;  x,y: qword;  BEGIN
x:=a[l+random(r-l+1)];
i:=l; j:=r;
while i<=j do      begin
  while a[i]<x do inc(i);
  while a[j]>x do dec(j);
  if i<=j then     begin
    y:=a[i];
       a[i]:=a[j];
             a[j]:=y;
    inc(i);
    dec(j)      end end;
if l<j then qsort(l,j);
if i<r then qsort(i,r)        END;

procedure step (j,k: byte);
      var i,kn,l,l0: byte;       BEGIN
{writeln(' step ',j,k);}
if (j=cm) and (k=cn) then        begin
  d[j,k]:=bnt[k];
  y[j]:=1;
  for kn:=1 to cn do if d[j,kn]>0 then
  for  i:=1 to d[j,kn] do y[j]:=y[j]*an[kn];
  dec(y[j]);
  if bm[j]<=y[j] then            begin
    x[j]:=x[j-1];
    for i:=1 to y[j] do x[j]:=x[j]*am[j];
    inc(na);
    a[na]:=x[j]                end end

else if (j=cm) then              begin
  d[j,k]:=bnt[k];
  step(j,k+1)                      end

else  if (k=cn) then             begin
  l0:=bnt[k];
  for l:=l0 downto 0 do          begin
  d[j,k]:=l;
  y[j]:=1;
  for kn:=1 to cn do if d[j,kn]>0 then
  for i:=1 to d[j,kn] do y[j]:=y[j]*an[kn];
  dec(y[j]);
  if bm[j]<=y[j] then            begin
    bnt[k]:=bnt[k]-l;
    x[j]:=x[j-1];
    for i:=1 to y[j] do x[j]:=x[j]*am[j];
    step(j+1,1);
    bnt[k]:=bnt[k]+l;      end end end

else                             begin
  l0:=bnt[k];
  for l:=l0 downto 0 do          begin
  d[j,k]:=l;
  bnt[k]:=bnt[k]-l;
  step(j,k+1);
  bnt[k]:=bnt[k]+l;       end end END;
                              BEGIN
assign(fi,'divisors.in');
reset(fi);
assign(fo,'divisors.out');
rewrite(fo);
readln(fi,m,n);
decomp(m, cm, am, bm);
decomp(n, cn, an, bn);
qn:=0;
for j:=1 to cn do begin
  bnt[j]:=bn[j];
  qn:=qn+bn[j]      end;
x[0]:=1;
na:=0;
if qn<cm then writeln(fo,'0')
         else                 begin
  step(1,1);
  if na=0 then writeln(fo,'0')
            else              begin
  qsort(1,na);
  write(fo,a[1]);
  for j:=2 to na do
  write(fo,' ',a[j]);
  writeln(fo)              end end;
close(fi);
close(fo)                      END.
